;8080 DISASSEMBLER BY WARD CHRISTENSEN AS
;DESCRIBED IN DR. DOBBS'S JOURNAL OF FEB 1977
;EDITED FOR USE WITH CP/M ASSEMBLER BY A.R.G.
;
;SEE SEDIT.ASM FOR COMPANION SYMBOL TABLE
;EDITOR
;
;
* DISASSEMBLER MINUS COMMENTS
* COMMENTS DELEATED BY DISASSEMBLY
ORG	3100H
FILE	EQU	3805H	;MEM FILE START STORED HERE
TYPE	EQU	409CH	;ASCII OUT FROM A RTN.
BBUF	EQU	3868H	;ADDR TO START DISAS STORED HERE
SYMTB	EQU	0C002H	;SYMBOL TABLE AREA
SPVR	EQU	401FH
START	IN	0FFH
	ANI	4
	JZ	NOSYM
	XRA	A
	STA	SYMTB
NOSYM	LHLD	FILE
	INX	H
	IN	0FFH
	ANI	80H
	JZ	NOSTR
	SHLD	FILE+2
NOSTR	LHLD	BBUF
DISAM	CALL	LINE
	JMP	DISAM
LINE	PUSH	H
	LHLD	FILE+2
	SHLD	LINAD
	POP	H
	MOV	A,H
	CALL	XO
	MOV	A,L
	CALL	XOB
	MOV	B,H
	MOV	C,L
	IN	0FFH
	ANI	1
	CNZ	PRTLB
	MVI	A,' '
	CALL	ZTYPE
	IN	0FFH
	ANI	' '
	JNZ	PRDB
	PUSH	H
	MOV	H,M
	LXI	B,OPTAB
ULP	LDAX	B
	ORA	A
	JZ	PRDBP
	ANA	H
	MOV	L,A
	INX	B
	LDAX	B
	CMP	L
	JZ	FOUND
	MOV	A,C
	ADI	6
	MOV	C,A
	JNC	ULP
	INR	B
	JMP	ULP
FOUND	INX	B
	LDAX	B
	STA	TYFLG
	PUSH	D
	MOV	E,A
	MVI	D,00H
	LXI	H,JMTBL
	DAD	D
	DAD	D
	DAD	D
	POP	D
	XTHL
	RET
JMTBL	JMP	TYPE0
	JMP	TYPE1
	JMP	TYPE2
	JMP	TYPE3
	JMP	TYPE4
	JMP	TYPE5
	JMP	TYPE6
	JMP	TYPE7
	JMP	TYPE8
	JMP	TYPE9
	JMP	TYPEA
	JMP	TYPEB
TYPE0	CALL	PROP
IXHRT	INX	H
	JMP	RET1
TYPE1	CALL	PROP
T1B	CALL	REG
	JMP	IXHRT
TYPE2	CALL	PROP
	CALL	REGM
	JMP	IXHRT
TYPE3	CALL	PROP
	CALL	XR
	JMP	IXHRT
TYPE4	CALL	PROP
	CALL	REGM
	CALL	COMMA
	JMP	T52
TYPE5	CALL	PROP
T52	INX	H
	MOV	A,M
	CALL	XO0
T54	MVI	A,'H'
	CALL	ZTYPE
	MOV	A,M
	INX	H
	PUSH	B
	MOV	B,A
	IN	0FFH
	ANI	10H
	MOV	A,B
	POP	B
	JZ	RET1
	CPI	' '
	JC	RET1
	CPI	5BH
	JNC	RET1
	LDA	TYFLG
	CPI	4
	JC	RET1
	CPI	6
	JNC	RET1
	DCX	H
	MOV	A,M
	INX	H
QCHAR	PUSH	6
	CALL	OQ
	POP	6
	MVI	A,''''
	CALL	ZTYPE
	JMP	RET1
TYPE6	CALL	PROP
	MOV	A,M
	CALL	XR
	CALL	COMMA
	JMP	TYP6H
PRT2X	CALL	SYMBO
	JC	RET1
TYP6H	INX	H
	MOV	B,M
	INX	H
	MOV	A,M
	CALL	XO0
	MOV	A,B
	CALL	XO
	JMP	T54
TYPE7	CALL	PROP
	CALL	SYMBO
	JC	RET1
	IN	0FFH
	ANI	08H
	JZ	PRT2X
	MVI	A,'L'
	CALL	ZTYPE
	INX	H
	MOV	B,M
	INX	H
	MOV	A,M
	CALL	XO
	MOV	A,B
	CALL	XO
	INX	H
	JMP	RET1
TYPE8	INX	B
	LDAX	B
	STA	CC1
	CALL	GETCC
	JMP	TYPE7
TYPE9	MVI	A,'R'
	STA	CC1
	CALL	GETCC
	JMP	TYPE0
TYPEA	CALL	PROP
	RAR
	RAR
	RAR
	ANI	07H
	ORI	'0'
	CALL	ZTYPE
	JMP	IXHRT
TYPEB	CALL	PROP
	CALL	REGM
	CALL	COMMA
	MOV	A,M
	JMP	T1B
COMMA	MVI	A,','
	JMP	ZTYPE
PRDBP	POP	H
PRDB	MVI	A,'D'
	CALL	ZTYPE
	MVI	A,'B'
	CALL	ZTYPE
	MVI	A,' '
	CALL	ZTYPE
	DCX	H
	IN	0FFH
	ANI	'0'
	CPI	'0'
	JNZ	T52
	INX	H
	MOV	A,M
	DCX	H
	CPI	' '
	JC	T52
	CPI	5BH
	JNC	T52
	INX	H
	INX	H
	JMP	QCHAR
GETCC	MOV	A,M
	RAR
	RAR
	ANI	0EH
	PUSH	H
	LXI	H,CCTAB
	CALL	ADD1
	MOV	A,M
	STA	CC1+1
	INX	H
	MOV	A,M
	STA	CC1+2
	POP	H
	LXI	B,TYFLG
	MVI	A,' '
	STA	CCB
	RET
CCTAB	MOV	C,M
	MOV	E,D
	MOV	E,D
	DB	20H
	MOV	C,M
	MOV	B,E
	MOV	B,E
	DB	20H
	MOV	D,B
	MOV	C,A
	MOV	D,B
	MOV	B,L
	MOV	D,B
	DB	20H
	MOV	C,L
	DB	20H
HEXL	RAR
	RAR
	RAR
	RAR
HEXR	ANI	0FH
	CPI	0AH
	JC	HEXRN
	ADI	07H
HEXRN	ADI	'0'
	RET
XO	PUSH	6
	CALL	HEXL
	CALL	ZTYPE
	POP	6
	CALL	HEXR
	JMP	ZTYPE
XOB	CALL	XO
	MVI	A,' '
	JMP	ZTYPE
OQ	PUSH	6
	MVI	A,' '
	CALL	ZTYPE
	MVI	A,''''
	CALL	ZTYPE
	POP	6
	JMP	ZTYPE
CQ	CALL	ZTYPE
	MVI	A,''''
	JMP	ZTYPE
PROP	PUSH	D
	MVI	D,04H
PROPL	INX	B
	LDAX	B
	CALL	ZTYPE
	DCR	D
	JNZ	PROPL
	LDAX	B
	CPI	' '
	MVI	A,' '
	CNZ	ZTYPE
	POP	D
	MOV	A,M
	RET
XR	RAR
	RAR
	RAR
	ANI	6
	CPI	6
	JNZ	REG
	MVI	A,'6'
	JMP	ZTYPE
REGM	RAR
	RAR
	RAR
REG	PUSH	H
	LXI	H,RTAB
	ANI	07H
	CALL	ADD1
	MOV	A,M
	POP	H
	JMP	ZTYPE
ADD1	ADD	L
	MOV	L,A
	RNC
	INR	H
	RET
RTAB	DB	'B'
	DB	'C'
	DB	'D'
	DB	'E'
	DB	'H'
	DB	'L'
	DB	'M'
	DB	'A'
XO0	CPI	0A0H
	JC	XO
	PUSH	6
	MVI	A,'0'
	CALL	ZTYPE
	POP	6
	JMP	XO
RET1	MVI	A,0DH
ZTYPE	PUSH	B
	MOV	B,A
	IN	0FFH
	RAL
	MOV	A,B
	POP	B
	JNC	TYPE
	PUSH	H
	LHLD	FILE+2
	MOV	M,A
	INX	H
	SHLD	FILE+2
	PUSH	6
	CALL	TYPE
	POP	6
	POP	H
	CPI	0DH
	RNZ
	PUSH	H
	LHLD	LINAD
	SHLD	LINUM
	DCX	H
	MOV	A,H
	CMA
	MOV	D,A
	MOV	A,L
	CMA
	MOV	E,A
	INX	D
	LHLD	FILE+2
	DAD	D
	MOV	A,L
	LHLD	LINAD
	DCX	H
	MOV	M,A
	LHLD	FILE+2
	SHLD	LINAD
	INX	H
	SHLD	FILE+2
	MOV	A,H
	CPI	'0'
	POP	H
	JNZ	CKX
END1	LHLD	FILE+2
	DCX	H
	MVI	M,01H
	SHLD	FILE+2
	LHLD	LINUM
	MVI	B,04H
	LXI	D,FILE+4
MOVLN	MOV	A,M
	STAX	D
	INX	H
	INX	D
	DCR	B
	JNZ	MOVLN
	JMP	SPVR
CKX	IN	1
	ANI	7FH
	CPI	'X'-40H
	RNZ
	JMP	END1
SYMBO	IN	0FFH
	ANI	05H
	RZ
	ANI	1
	JNZ	FRMTB
	CALL	SYBLD
	ORA	A
	RET
FRMTB	INX	H
	MOV	C,M
	INX	H
	MOV	B,M
	INX	H
	CALL	PRTLB
	RC
	DCX	H
	DCX	H
	DCX	H
	ORA	A
	RET
PRTLB	CALL	LOOKU
	CMC
	RNC
	MVI	B,05H
SYPLP	LDAX	D
	INX	D
	ORA	A
	STC
	RZ
	CALL	ZTYPE
	DCR	B
	STC
	RZ
	JMP	SYPLP
SYBLD	INX	H
	MOV	C,M
	INX	H
	MOV	B,M
	DCX	H
	DCX	H
	CALL	LOOKU
	RNC
	MVI	A,'L'
	STAX	D
	INX	D
	MOV	A,B
	CALL	SYSTX
	MOV	A,C
	CALL	SYSTX
	MOV	A,B
	STAX	D
	INX	D
	MOV	A,C
	STAX	D
	XRA	A
	INX	D
	STAX	D
	STC
	RET
SYSTX	PUSH	6
	CALL	HEXL
	STAX	D
	INX	D
	POP	6
	CALL	HEXR
	STAX	D
	INX	D
	RET
LOOKU	LXI	D,0C002H
LULP	LDAX	D
	ORA	A
	STC
	RZ
	INX	D
	INX	D
	INX	D
	INX	D
	INX	D
	LDAX	D
	CMP	B
	INX	D
	JNZ	LUNO
	LDAX	D
	CMP	C
	JNZ	LUNO
	DCX	D
	DCX	D
	DCX	D
	DCX	D
	DCX	D
	DCX	D
	ORA	A
	RET
LUNO	INX	D
	JMP	LULP
	*@2A0-3
	*
OPTAB	DB	0FFH
	DW	0
	DW	'ON'
	DW	' P'
	DB	0FFH
	DW	7
	DW	'LR'
	DW	' C'
	DB	0FFH
	DW	0FH
	DW	'RR'
	DW	' C'
	DB	0FFH
	DW	17H
	DW	'AR'
	DW	' L'
	DB	0FFH
	DW	0EBH
	DW	'CX'
	DW	'GH'
	DB	0FFH
	DW	1FH
	DW	'AR'
	DW	' R'
	DB	0FFH
	DW	722H
	DW	'HS'
	DW	'DL'
	DB	0FFH
	DW	27H
	DW	'AD'
	DW	' A'
	DB	0FFH
	DW	72AH
	DW	'HL'
	DW	'DL'
	DB	0FFH
	DW	2FH
	DW	'MC'
	DW	' A'
	DB	0FFH
	DW	732H
	DW	'TS'
	DW	' A'
	DB	0FFH
	DW	37H
	DW	'TS'
	DW	' C'
	DB	0FFH
	DW	73AH
	DW	'DL'
	DW	' A'
	DB	0FFH
	DW	3FH
	DW	'MC'
	DW	' C'
	DB	0FFH
	DW	76H
	DW	'LH' ;HLT PRECEEDS MOV TO
	DW	' T' ;PREVENT 'MOV M,M'
	DB	0C0H
	DW	0B40H
	DW	'OM'
	DW	' V'
	DB	0FFH
	DW	7C3H
	DW	'MJ'
	DW	' P'
	DB	0FFH
	DW	0C9H
	DW	'ER'
	DW	' T'
	DB	0FFH
	DW	7CDH
	DW	'AC'
	DW	'LL'
	DB	0FFH
	DW	5D3H
	DW	'UO'
	DW	' T'
	DB	0FFH
	DW	5DBH
	DW	'NI'
	DW	'		'
	DB	0FFH
	DW	0E3H
	DW	'TX'
	DW	'LH'
	DB	0FFH
	DW	0E9H
	DW	'CP'
	DW	'LH'
	DB	0FFH
	DW	0F3H
	DW	'ID'
	DW	'  '
	DB	0FFH
	DW	0FBH
	DW	'IE'
	DW	'  '
	DB	0FFH
	DW	0F9H
	DW	'PS'
	DW	'LH'
	DB	0FFH
	DW	5C6H
	DW	'DA'
	DW	' I'
	DB	0FFH
	DW	5CEH
	DW	'CA'
	DW	' I'
	DB	0FFH
	DW	5D6H
	DW	'US'
	DW	' I'
	DB	0FFH
	DW	5DEH
	DW	'BS'
	DW	' I'
	DB	0FFH
	DW	5E6H
	DW	'NA'
	DW	' I'
	DB	0FFH
	DW	5EEH
	DW	'RX'
	DW	' I'
	DB	0FFH
	DW	5F6H
	DW	'RO'
	DW	' I'
	DB	0FFH
	DW	5FEH
	DW	'PC'
	DW	' I'
	DB	0F8H
	DW	180H
	DW	'DA'
	DW	' D'
	DB	0F8H
	DW	188H
	DW	'DA'
	DW	' C'
	DB	0F8H
	DW	190H
	DW	'US'
	DW	' B'
	DB	0F8H
	DW	198H
	DW	'BS'
	DW	' B'
	DB	0F8H
	DW	1A0H
	DW	'NA'
	DW	' A'
	DB	0F8H
	DW	1A8H
	DW	'RX'
	DW	' A'
	DB	0F8H
	DW	1B0H
	DW	'RO'
	DW	' A'
	DB	0F8H
	DW	1B8H
	DW	'MC'
	DW	' P'
	DB	0C7H
	DW	204H
	DW	'NI'
	DW	' R'
	DB	0C7H
	DW	205H
	DW	'CD'
	DW	' R'
	DB	0EFH
	DW	302H
	DW	'TS'
	DW	'XA'
	DB	0EFH
	DW	30AH
	DW	'DL'
	DW	'XA'
	DB	0CFH
	DW	3C1H
	DW	'OP'
	DW	' P'
	DB	0CFH
	DW	3C5H
	DW	'UP'
	DW	'HS'
	DB	0C7H
	DW	406H
	DW	'VM'
	DW	' I'
	DB	0CFH
	DW	303H
	DW	'NI'
	DW	' X'
	DB	0CFH
	DW	309H
	DW	'AD'
	DW	' D'
	DB	0CFH
	DW	30BH
	DW	'CD'
	DW	' X'
	DB	0C7H
	DW	8C2H
	DW	'.J'
	DW	'..'
	DB	0C7H
	DW	8C4H
	DW	'.C'
	DW	'..'
	DB	0CFH
	DW	601H
	DW	'XL'
	DW	' I'
	DB	0C7H
	DW	9C0H
	DW	'.R'
	DW	'..'
	DB	0C7H
	DW	0AC7H
	DW	'SR'
	DW	' T'
	DB	0	;(END OF TABLE)
*----------WORK	AREA----------*
 * NOTE: DISASSEMBLER IS ROM-ABLE
 * (= PROTECTABLE) IF THIS AREA
 * IS MOVED TO READ-WRITE MEMORY.
LINAD	DS	2	;ADDR OF START OF CUR LINE
LINUM	DS	2	;ADDR OF CUR LINE'S LINE #
TYFLG	DS	1	;OP CODE TYPE
CC1	DS	3	;CONDITION STORED HERE
CCB	DS	1	;BLANK FOLLOWING COND CODE
	END
	&"