;CP/M NOTE - EDITED FOR CP/M ASSEMBLER BY A.R.G.
;SEE DISASSM1.ASM FOR MAIN PROGRAM BY
;WARD CHRISTENSEN
;
;
*@2C0 1
* * * * * * * * * * * * * * * *
*  SYMBOL TABLE EDIT ROUTINE  *
*        FOR USE WITH         *
*    8 0 8 0  DISASSEMBLER    *
* * * * * * * * * * * * * * * *
TYPE	EQU	409CH	;TYPE ASCII FROM A
KEYIN	EQU	408EH	;KEYIN ASCII TO A
;
; PLACE THE ENTRY NUMBER FROM THE
; SYMBOL TABLE AT WHICH YOU WANT TO
; START EDITING INTO THE FOLLOWING
; WORD (0 FOR START OF TABLE)
BBUF	EQU	3868H	;PTCO PARM BUFFER+2
;
SYMTB	EQU	0C002H	;SYMBOL TABLE START
	ORG	3600H
	LHLD	BBUF	;GET TABLE ENTRY #
	MOV	D,H	;MOVE ENTRY #
	MOV	E,L	;..TO D,E
; MULTIPLY ENTRY BY 7 BYTES/ENTRY
	DAD	H	;TIMES 2
	DAD	D	;TIMES 3
	DAD	H	;TIMES 6
	DAD	D	;TIMES 7
	LXI	D,SYMTB	;POINT DE TO TABLE
	DAD	D	;POINT HL TO PROPER ENTRY
LABEL	MOV	A,M	;GET FIRST CHAR
	ORA	A	;END OF TABLE?
	RZ		;RETURN TO CALLER IF SO
; PRINT EXISTING LABEL 
	MVI	B,5	;MAX LABEL LENGTH
PRINT	MOV	A,M	;GET CHAR OF LABEL
	ORA	A	;END OF SHORT LABEL?
	JZ	ENDP	;..YES - END OF PRINT
	CALL	TYPE	;TYPE THE CHAR
	INX	H	;POINT TO NEXT
	DCR	B	;DONE?
	JNZ	PRINT	;NO
; END OF LABEL
ENDP	MOV	A,B	;GET LABEL RESIDUAL COUNT
	ADD	L	;ADD TO H,L
	MOV	L,A	;MOVE IT BACK
	JNC	NC	;SKIP ADD IF NO CARRY INTO H
	INR	H	;ADD IN CARRY
NC	CALL	SPACE	;PRINT A SPACE
; PRINT HEX LABEL VALUE
	MOV	A,M	;FIRST CHAR
	CALL	XO	;PRINT IN HEX
	INX	H	;POINT TO SECOND CHAR
	MOV	A,M	;SECOND CHAR
	CALL	XOB	;SECOND CHAR
	LXI	D,-6	;BACK HL UP TO
	DAD	D	;..START OF LABEL
	PUSH	H	;SAVE START OF LBL ADDR
;
; READ NEW LABEL INTO TABLE
;
	MVI	D,5	;MAX LABEL LENGTH
INPLP	CALL	KEYIN	;GET CHAR FOR LABEL
	CPI	'X'-40H	;CTL-X?
	JZ	 ABORT	;RETURN IF CTL-X
	PUSH	PSW	;SAVE THE CHAR
	CALL	TYPE	;ECHO IT
	POP	PSW	;RESTORE THE CHAR
	CPI	7FH	;DEL CHAR? (BACKSPACE?)
	JNZ	NOTBS	;..NO
; PROCESS BACKSPACE
	DCX	H	;BACK UP 1 CHAR
	INR	D	;ADJUST COUNT
; PRINT DELETED CHAR IN SLASHES
	MVI	A,'/'
	CALL	TYPE
	MOV	A,M	;GET DELETED CHAR
	CALL	TYPE
	MVI	A,'/'
	CALL	TYPE
	JMP	INPLP
NOTBS	CPI	13	;C/R?
	JZ	ENDLB	;YES - END OF LABEL
	MOV	M,A	;STORE CHAR INTO TABLE
	INX	H	;POINT TO NEXT POSITION
	DCR	D	;5 CHARS?
	JNZ	INPLP	;NO - GO GET MORE
	MVI	A,13	;GET ASCII C/R
	CALL	TYPE	;C/R
;	END	OF	;LABEL, PAD W/0'S IF < 5 CHARS
ENDLB	MOV	A,D	;GET RESIDUAL LABEL COUNT
	ORA	A	;ZERO?
	JZ	NOLAB	;YES - DON'T STORE THE ZERO
	CPI	5	;NO LABEL CHANGE?
	JZ	NOLAB	;YES - LEAVE ALONE
	XRA	A	;GET A ZERO
	MOV	M,A	;STORE INTO TABLE
PADLB	INX	H	;POINT TO NEXT POSITION
	DCR	D	;STILL MORE RESIDUAL COUNT?
	JNZ	PADLB	;STORE MORE UNTIL DONE
NOLAB	POP	H	;RESTORE START OF LBL ADDR
	LXI	D,7	;5 FOR LABEL, 2 FOR VALUE
	DAD	D	;POINT TO NEXT LABEL
	JMP	LABEL	;LOOP FOR NEXT LABEL
;
; ROUTINE TO PRINT A SPACE
;
SPACE	MVI	A,' '
	JMP	TYPE	;TYPE THE SPACE
;
; HEX OUTPUT ROUTINES
;
;---> HEX OUTPUT W/BLANK
XOB	CALL	XO	;PRINT HEX
	JMP	SPACE	;..THEN SPACE
;---> HEX OUTPUT
XO	PUSH	PSW	;SAVE INCOMING A REG
	RAR		; SHIFT
	RAR		; ..LEFT NIBBLE
	RAR		; ..INTO THE
	RAR		; ..THE RIGHT NIBBLE
	CALL	NIBBL	;PRINT LEFT NIBBLE
	POP	PSW	;RESTORE CHAR
;---> PRINT 1 HEX NIBBLE
;   (NIBBLE IS HALF A BYTE)
NIBBL	ANI	15	;ISOLATE NIBBLE
	CPI	10	;ALPHA HEX?
	JC	HEXNU	;NO, NUMBER
	ADI	7	;FUDGE FOR ALPHA HEX
HEXNU	ADI	'0'	;MAKE PRINTABLE
	JMP	TYPE	;PRINT NIBBLE, RETURN
ABORT	POP	H	;DELETE PUSHED H
	RET		; RETURN TO CALLER
