; THIS ROUTINE LOADS A PROGRAM DESIGNED TO RUN AT LOC 0000
; INTO LOC 100, THEN MOVES IT DOWN TO LOC 0000 AND COMES
; IN RUNNING.
;
;   R S MASON				9-21-77
;
;    TO USE:
;	1)	SET RUNLOC TO THE EXECUTION ADDRESS OF PROGRAM
;	2)	SET PGMEND TO THE END OF PROGRAM WHEN IT IS LOADED AT
;		LOC 100H
;	3)	ASSEMBLE THIS ROUTINE
;	4)	CALL DDT
;	5)	TYPE 'I<PGM NAME>'
;	6)	TYPE 'R3' (LOADS YOUR PROG AT LOC 103H)
;	7)	TYPE 'IMOVDOWN.HEX'
;	8)	TYPE 'R' (OVERLAYS THIS ROUTINE)
;	9)	TYPE 'CNTL C'
;	10)	TYPE 'SAVE <N> <PGM NAME.COM>' (N=PAGES)
;
RUNLOC	EQU	0000		;RUNNING ADDRESS
PGMEND	EQU	3C60H		;END OF UNMOVED PROGRAM
;
	ORG 100H			;START WITH A JUMP
	JMP	MOVDOWN			;TO MOVDOWN
;
	ORG PGMEND+4
;
MOVDOWN	LXI	D,00		;LOAD STARTING DESTINATION
	LXI	H,103H		;LOAD STARTING SOURCE
	LXI	B,PGMEND+1	;LOAD SOURCE END
LOOP	MOV	A,M		;GET DATA
	INX	H		;BUMP POINTER
	XCHG			;SET FOR DESTINATION
	MOV	M,A		;PUT DATA
	INX	H		;BUMP POINTER
	XCHG			;SET FOR SOURCE
	MOV	A,H		;GET HIGH BYTE OF SOURCE
	CMP	B		;NEARLY DONE?
	JNZ	LOOP		;N-GO AGAIN
	MOV	A,L		;GET LO BYTE OF SOURCE
	CMP	C		;DONE?
	JNZ	LOOP		;N-GO AGAIN
	JMP	RUNLOC		;Y-EXECUTE MOVED PROGRAM
END	END
